#encoding: UTF-8 
=begin
/***************************************************************************
 *   ©2016 Michael Uplawski <michael.uplawski@uplawski.eu>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end

class Mapping

  include 'Logging'

  @@TMap = {
    'INT' => 1, 
    'TINYINT' => 1, 
    'SMALLINT' => 1, 
    'MEDIUMINT' => 1, 
    'BIGINT' => 1, 
    'UNSIGNED BIGINT' => 1, 
    'VARCHAR' => 0, 
    'CHARACTER' => 0, 
    'VARYING CHARACTER' => 0, 
    'LONGVARCHAR' => 0, 
    'TEXT' => 0, 
    'BLOB' => 0, 
    'INTEGER' => 1, 
    'FLOAT' => 2, 
    'REAL' => 2, 
    'DOUBLE' => 2
  } 

  # Constructor
  # Creates a mapping for the table of name 'table'
  # and basedon the table_info.
  def initialize table, table_info, content
    init_logger()

    @table_name = table
    @mapping = []

    table_info.each do |field|
      @log.debug('field is ' << (field ? field.to_s : ' N I L ')
      field_name = field['name']

      # date- and time-fields have to be stored as text.
      ftype = 0 
      if( !@date_fields.include?(field_name) && !@time_fields.include?(field_name) )
        # -----> determine the simple dbf data-type that has to do. <----
        type_mapping = tmap.detect{|key, value| field['type'].upcase.start_with?(key) }
        ftype = type_mapping[1] if type_mapping && type_mapping.respond_to?(:to_ary)
      end
      
      @mapping << OpenStruct.new(field_name => ftype)
    end
  end
end
