#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2011-2015, Michael Uplawski				           * 
 *   <michael.uplawski@uplawski.eu>  					   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         * 
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end


RD = File.expand_path(File.dirname(__FILE__) ) +  File::SEPARATOR if !defined?(RD)

require 'yaml'
require_relative 'file_checking'


=begin 
 A way to produce translated text in a ruby-program.
 Translations are read from a file "translations" in the program folder.
=end
module Translating
  # There are better ways to extend a translated 
  # string, but I keep the 'wild-card' for 
  # historical reasons.
  @@awild = 'XX'

  @@lang = nil 
  @@lang_file = format("%s%s", RD, 'LANG')  
  @@tr = YAML::load_file("#{RD}translations")

  # find the current language-setting and return it.
  def self.language()
    if @@lang == nil
      r = ENV['LANG']
      if(r)
	@@lang = r[0, 2]
      elsif( !File_Checking::file_check(@@lang_file, [:exist?, :readable?]) && File::size(@@lang_file) >= 2)
	File::open(@@lang_file, 'r') {|f| @@lang = f.readline}
	@@lang.chomp!.downcase! if @@lang
      end
    end
    @@lang = 'en' if !@@lang
  end

  # Translate a string to the currently set langage. 
  # The args parameter may contain replacement-text which 
  # will appear at the positions indicated by wildcard-characters
  # in the original string.
  def self.trl(t, *args)
    Translating::language()
    lt = @@tr[t]
    if(lt)
      lt = lt[@@lang]
    else
      # File.open('/tmp/mtf', 'a+') {|f| f << t << "\n"}
      puts "\nTRANSLATION MISSING: \"" << t << "\""
    end
    lt ||= t
    if(args && !args.empty?)
      i = -1 
      lt = lt.gsub(@@awild) do |a| 
	i += 1
	args.flatten[i]
      end
      lt += args[i + 1, args.length].join
    end
    return lt
  end

  # Translate a string to the currently set langage. 
  # The args parameter may contain replacement-text which 
  # will appear at the positions indicated by wildcard-characters
  # in the original string.
  def trl(t, *args )
    Translating::trl(t, args)
  end
end
